using Bp.Sync.BackEnd.Infrastructure.Repositories;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using MediatR;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.Inventories.Accounts
{
    public class SyncAccountHandler : IRequestHandler<SyncAccountCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IAccountRepository _AccountRepository;
        private readonly IBus _bus;

        public SyncAccountHandler(IConfiguration configuration, IAccountRepository AccountRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("InventoryConnection");
            _dbConnection = new SqlConnection(connectionString);
            _AccountRepository = AccountRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncAccountCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticAccount", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} Accounts" };
            }

            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }
            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var Accounts = await _dbConnection.QueryAsync<Domain.Entities.Inventories.Accounts.Account>("Sync_Account_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (Accounts.Any())
                {
                    var AccountRs = Accounts.ToAccounts();
                    var rs2 = await _AccountRepository.AddManyAsync(AccountRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_Account_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{AccountRs.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}